Cover

Documentation

JCrystal

Java Crystal Morphology Editor/Viewer

Version 1.05

© JCrystalSoft, 2000-2006


Introduction

JCrystal was originally written on request of Monte Nichols (Aleph Enterprises). An early version has been available since 1999. Dave Barthelmy has used that older version and the JCrystalApplet extensively for his online mineral database at www.webmineral.com . This motivated me to write this newer version, which is now available for download.

JCrystal draws crystal shapes for normal crystals and icosahedral quasicrystals. It is possible to export webpages in the HTML language, which use the provided JCrystalApplet, so that crystal shapes can be viewed within a Java-enabled webbrowser, such as Microsoft Internet Explorer (MSIE) or Netscape (NS). This is perhaps JCrystal's most attractive feature. JCrystal itself has more rendering options than the applet. It might thus be used as a interface for the creation of interactive webpages. Please note that webbrowsers do usually not support the latest Java language version, which is why the rendering options in the JCrystalApplet are not the same as in JCrystal (the applet is written in an older version of the Java language).

JCrystal can produce PostScript graphics for the crystal shapes and the stereographic projections. In order to view and print PostScript files you should install the free programs GhostView with GhostScript . GhostView is the user interface to GhostScript, which is a PostScript interpreter.

If you encounter problems or bugs in JCrystal we would appreciate if you use the menu [Help][submit bug report] feature to notify us (requires Internet connection).

Sample files

Most sample files in the directory "hkl\" and all templates in the directory "hkl\Dave_Barthelmy" are provided by Mr. Dave Barthelmy. When you select the menu [Options][create templates] some 3600 template files will be created in the directory "hkl\templates". The templates are not the complete crystal shapes. They contain the mineral name, cell parameters, symmetry group code and a default hkl-list that has to be modified by the user for obtaining the correct shapes. The sample files in the directory "hkl\Udo_Behner" were provided by Mr. Udo Behner. Some import file samples for the SHAPE6 and FACES3.5 programs have been included from their demo distributions.

Disclaimer

The software JCrystal is sold on an "as is" basis without any warranty either expressed or implied as to its performance, quality, or fitness for any particular purpose. The entire risk is with the buyer. JCrystalSoft's liability for any damage arising out of the use of this software shall be limited to the price for this product. In no event shall JCrystalSoft be liable for indirect, special or consequential damages resulting from the use of the JCrystal software. JCrystalSoft will replace any CD which is found to be defective. This software product is copyrighted and all rights are reserved by JCrystalSoft and the program's author Dr. Steffen Weber. The software is licensed by JCrystalSoft to the original purchaser. Copying and duplicating (except for purposes of backup), selling, or otherwise distributing this product is not allowed.

JCrystalSoft reserves the right to make changes or improvements in this software at any time and without notice.

Dr. Steffen Weber
author of JCrystal


Features

Main features

  • calculation of crystal shapes
  • icosahedral quasicrystals
  • export of web pages with interactive Java applet
  • intuitive hkl list editor
  • two form selectors
  • automatic distance adjustments for faces lying outside
  • photo link and annotation option
  • synchronized Wulff net monitor
  • file history menu
  • Internet links
  • translucent crystal rendering
  • wire frame, shaded, anaglyph rendering modes
  • output of GIF, JPG, PostScript, VRML, HTML, POVray files

Other features

  • Unit cell visualizer
  • Stereographic projection simulation
  • Laue pattern simulation
  • Periodic table utility
  • Print selected paper models

Importing files

  • import of files from FACES 3.5
  • import of SHAPE 6 face details files (*.SHD)

Shape's details files *.SHD must be for single crystals not twins!
FACES 3.5 files do not contain suitable distance values for the faces! JCrystal tries to reproduce the hkl-list from the given forms, but the distances have to be manually adjusted to produce the same shape as in the FACES 3.5 program.


What is new ?

version 1.05 (11/04/2006)

  • changed HTML helpfiles to this CHM helpfile
  • updated JCrystalApplet
  • included optional Applet for SUN-JVM with transparency rendering

version 1.04 (03/28/2005)

  • updated Laue simulation module
  • changed CD distribution to downloadable installation

version 1.03 (12/17/2003)

  • updated Laue simulation module
  • new sample files courtesy of Dave Barthelmy ( www.webmineral.com )
  • removed automatic internet update check

version 1.02 (01/20/2001)

  • use DELETE key to delete selected faces !
  • use ENTER to select/unselect all faces with same color !
  • do not automatically save file when recalculating
  • SPACE key also starts animation now like with the applet
  • menu item [File][reload]
  • input files may give forms instead of all faces
  • output of POVRAY files

version 1.01 (01/10/2001)

  • print selected paper models
  • automatic update notification & download
  • advanced parameters editable
  • pop-up menu for JCrystalApplet
  • direct links to web-based mineral databases
  • new sample files

version 1.00 (12/01/2000)

  • official release of JCrystal


Getting started

The installation procedure will have put a "JCrystal"-shortcut on your desktop. Double-click it for launching JCrystal.

When you run JCrystal for the first time you will be asked to input the Authorization key, which was emailed to you by JCrystalSoft. If you did not receive a registration key within 24 hours please contact jcrystalsoft@gmail.com . It could be that you gave an invalid email address or that your email server rejected the email coming from JCrystalSoft.

1.

The key is case sensitive! Use copy and paste in order to avoid misspelling. Then hit ENTER or click OK to start JCrystal. A message box will show a confirmation if your registration was accepted.

2.

If the JCrystal window does not appear within a few seconds double-click the shortcut icon again. After the JCrystal window appeared click the [open file] icon or select the [dir] tab.

3.

The drop-down list with favorite folders contains also two other folders with sample files namely "hkl\Dave_Barthelmy" and "hkl\Udo_Behner". You may select any of these folders for accessing sample files.

Select a file from the provided samples. Double-click on the filename or click the [open] button.

4.

Right-mouse-click on display area to switch to user color mode and select [html] tab.

5.

Click the [create] button to create a web page with the JCrystalApplet. Then your default webbrowser should open and display the generated HTML page with the embedded JCrystalApplet showing the crystal.


JCRYSTAL (c)S.Weber ( crystal shape, crystal morphology )

Editor

The editor features several text fields for title, unit cell dimensions and the hkl list. On its bottom is the color chooser for selecting the crystals mono-color, background color and individual face colors.

  1. headline or title

  2. unit cell constants

  3. table with hkl and distance values

  4. face select checkbox (right mouse click assigns chosen color)
    After checking/unchecking press ENTER key for checking/unchecking all other faces with the same color
    Press DELETE key to remove all selected faces from the list.

  5. color chooser (see description below)

  6. open color chooser for face color

  7. open file

  8. new file

  9. save file

  10. calculate / recalculate

  11. automatic distance adjustment (reduces distances of faces that are outside the current polyhedron)

Table

  • 1.column:
    checkbox, select it with left mouse button. Assign a color to it with the right mouse button.
  • 2-4.column:
    h k l (integer or real numbers)
  • 5. column:
    central distance, editable manually or by using a slider if that face's checkbox is selected.

Color chooser

left mouse button drag
change crystal's mono-color
right mouse button click
change crystal's mono-color
left mouse button click
select color for faces;
then you may click at the checkbox of a face with the right mouse button, in order to assign that color to it


File Browser

The file browser features a "favorite folders" list, where directories can be added /removed. The browser consists of several slider panes whose borders may be dragged to adjust their area.

  1. shows presently selected directory
  2. add directory to favorite's list
  3. remove directory from favorite's list
  4. refresh file name list
  5. favorite directory list (drop down list)
  6. directory browser
  7. directory contents, filename list (double click for opening file)
  8. text viewer for selected file
  9. number of files in list
  10. filename extension filter (*.*, *.hkl, *.jcr)
  11. load file (if not already double clicked)


Form Selector

This form selector produces a list of equivalent hkl for a given form and chosen point group symmetry.

  1. select point group
  2. give form's hkl (separated by SPACE)
  3. give central distance
  4. face color
  5. calculate equivalent hkl
  6. number of equivalent hkl
  7. hkl list (lines may be deleted manually)
  8. add all the hkl in this list to the editor's list
  9. clear list


Options Dialog

This dialog lets the user adjust various parameters for the crystal and background display, which should be self-explanatory.


HTML Creator

This dialog lets the user adjust various parameters for the web page creation and the JCrystalApplet.


Photo Viewer

The photo viewer tab lets you assign a photo to a generated shape. Photos can be downloaded from various websites listed in JCrystal's Internet links or scanned from books. Since all images on the Internet are usually copyrighted by their photographers only one sample image could be included with the JCrystal CD. To select a photo click at the photo display area.


Wulff-net Monitor

This tab shows a Wulff-net with the stereographic projection of the face poles of the displayed crystal. The plot is synchronized with the crystal rotation.

  1. Wulff net monitor
  2. hemisphere selector
  3. open angle measurement tool


Main Window

The main window consists of the canvas (display area), the menu bar and the toolbar. The canvas itself has the most interactive functions. It reacts on mouse events on keyboard events. You might have to click on the canvas first before it reacts to keyboard events!

Toolbar

Some buttons have different meanings for the left mouse button (L) or the right mouse button (R).

  1. rotation mode (mouse drags for rotation)
  2. zoom mode (mouse drags for rotation)
  3. switch editor panel on/off
  4. fit to screen
  5. L-rotate left, R-rotate right
  6. L-rotate up, R-rotate down
  7. L-counter clockwise, R-clockwise
  8. L-zoom in, R-zoom out
  9. stereo mode on/off
  10. orthonormal/perspective projection
  11. L-face normals on/off, R-normal color
  12. L-show hkl, R-hkl color
  13. L-show face number, R-face number color
  14. L-show vertex number, R-vertex number color
  15. print
  16. monocolor, user color, wireframe, anaglyph modes


Directories

The directory tree of JCrystal is shown below.

..\JCrystal\hkl\

..\JCrystal\html\

..\JCrystal\lib\

..\JCrystal\pic\

..\JCrystal\ps\

..\JCrystal\vrml\

..\JCrystal\povray\

input files for crystal faces

saved html files for the JCrystalApplet

JCrystal files (!do not edit any file)

saved GIF and JPG image files

saved PostScript files

saved VRML files

saved POVray files


File Types

Import files

  • JCrystal files with facet data (*.*, *.hkl, *.jcr,*.txt) (extension does not matter)
  • image files for photo view (*.gif, *.jpg)
  • import of files from FACES 3.5 (*.fac)
  • import of SHAPE 6 face details files (*.shd)

    Shape's details files *.SHD must be for single crystals not twins!
    FACES 3.5 files do not contain suitable distance values for the faces! JCrystal tries to reproduce the hkl-list from the given forms, but the distances have to be manually adjusted to produce the same shape as in the FACES 3.5 program.

Export files

  • JCrystal files with facet data (*.hkl, *.jcr)
  • image files (*.gif, *.jpg)
  • Vrml files -Virtual Reality Modeling Language (*.wrl)
  • PostScript graphics files (*.ps)
  • POVray files (*.pov) for ray tracing
  • Interactive web pages (*.html)

Input format

JCrystal's text input files use a very simple format. All numbers have to be separated by a SPACE.

click here to see details


File Format

JCrystal's Input format

JCrystal's text input files use a very simple format. All numbers have to be separated by a SPACE. When you use another text editor, such as Notepad for creating files, you may specify forms, in order to minimize the necessary typing. However, JCrystal saves the hkl-files always as the full face list.

1.When only faces are listed:

  • 1.line - some title
  • 2.line - cell parameters
  • 3.line - number of faces
  • from 4.line - h k l dist R G B (RGB are color values)

e.g.:

this is a cube
1 1 1 90 90 90
6
 1  0  0  1.0  255 0 0
 0  1  0  1.0  255 0 0
 0  0  1  1.0  255 0 0
-1  0  0  1.0  255 0 0
 0 -1  0  1.0  255 0 0
 0  0 -1  1.0  255 0 0

2.When forms are listed:

  • 1.line - some title
  • 2.line - cell parameters + point group number
  • 3.line - number of faces
  • from 4.line - h k l dist R G B "form"-keyword
this is a distorted cube-octahedron 1
1 1 90 90 90 32
3
 1  0  0  1.0  255 0   0    form
 1  1  1  1.0  0   0   255  form
 1  1  1  0.7  0   255 0

In this example the last green (111)-face is overwriting the blue (111)-face that was generated from the {111}-form

Point group numbers and symbols as used by JCrystal

 #   symbol
 1   1
 2  -1
 3   2
 4   m
 5   2/m
 6   222
 7   mm2
 8   mmm
 9   3
10  -3
11   32
12   3m
13  -3m
14   4
15  -4
16   422
17   4/m
18   4mm
19  -42m
20   4/mmm
21   6
22  -6
23  -6m2
24   622
25   6/m
26   6mm
27   6/mmm
28   23
29   432
30   m-3
31  -43m
32   m-3m
33   235
34   m-3-5


Menus

[File] menu
open hkl-file | open input file with hkl-list
new hkl-file | clears the editor for creating a new hkl-file
reload | reload currently loaded hkl-file
save as PS | Write a PostScript file. You should use the Public Domain software GHOSTSCRIPT+GHOSTVIEW for viewing and printing these files. If you do so you may print to any printer that is installed on your system, i.e. you do not need a PostScript printer!
save as HTML | write a HTML file of the current shape for using with the JCrystalApplet in a web page. You may also embed that code manually into other web pages of yours.
save as JPG | saves the current display as a JPG file (more than 65000 colors).
save as GIF | saves the current display as a GIF file (max.256 colors).
save as VRML | saves the shape in VRML (virtual reality modeling language) format for viewing in a web browser or with a stand-alone VRML viewer like GLview3.6 (I highly recommend to download the latter, Windows only).
add to VRML | This is a simple way to create interpenetrating crystals. If you have saved a VRML file you may rotate your crystal and then use this feature to add the rotated one. A VRML viewer would then display both as interpenetrating ones.
save as POVRAY | save the crystal shape as *.pov file for use with the free raytracing software POVray
print | Print the current content of screen to a specified printer. You may also consider just saving the image as GIF/JPG and then use any other graphics software to view and print the image.
Exit | Quit JCrystal
[View] menu
editor | switch the editor panel on/off (larger display area)
distance slider | switch the slider for modifying the central distances of selected faces on/off
editor swap side | switch locations of controls to the LEFT/RIGHT
view VRML file | start VRML viewer for viewing the last saved VRML file.
GUI appearance .. | select between WINDOWS look or JAVA look for the user interface
1. unit cell viewer | start unit cell and vector visualization program
2. stereographic projection | start Wulff net plotting program
3. Laue patterns | start Laue pattern simulation program
4. periodic table | start interactive periodic table of elements
5. paper models | print selected polyhedra as unfolded paper models
[Edit] menu
form explorer | open the extended form explorer, which also allows for mouse input
unselect all faces | unselect all faces presently selected in the editor
remove selected faces | remove selected faces form the editor's hkl list
reset distance slider | sets the slider knob to 0. If faces are selected their modified distances will be reset again. If you do not want them to reset uncheck them first before using this option.
advanced .. | change the tolerance value used during the generation of faces (maximum allowed distance of some vertex to a facet in order to used as a vertex of that facet ) Sometimes when there are almost parallel faces joining the vertices of one may be incorrectly be assigned to the other one. One can either adjust the distances of the faces to avoid incorrect rendering or try to change the tolerance value. For the automatic distance adjustment (always reducing distance) modify the distance decrement (0.025, 0.05, 0.1) and the maximum number of cycles (needed to avoid infinite loops leading to program hang-up). These values will also be given to the JCrystalApplet, so that it can draw the shape using the same criteria as JCrystal.
automatic distance | Use when some faces are not visible because their distances are too large. JCrystal then decreases the distances until the faces become visible. The distances can then be adjusted further by using the distance slider or by manual input.
[Display] menu
fit to screen | try to fit crystal to display area
shaded | shaded mono-colored crystal. The color can be changed by dragging with the pressed left mouse button over the color chooser tool.(a pressed right mouse button would change the background color!)
custom color | shaded crystal with specified face colors. If you click at the color chooser a color is selected and shown in the small color box. Then you may click at the checkbox of a face with the right mouse button, in order to assign that color to the face.
wire frame | show wire frame model
anaglyph | red-blue glasses needed for 3D effect
vertices | show only vertex positions as dots
line drawing 1 | show transparent black\white drawing
line drawing 2 | show solid black\white drawing
show indices | show hkl values for each facet (you may also type the character "i" to the same effect)
show face numbers | show serial number of each face (you may also type the character "n" to the same effect)
show vertex numbers | show serial number of each vertex (you may also type the character "v" to the same effect)
show edges | in the modes shaded and custom color the edges of the faces can be set to visible/invisible
show normals | shows the normal vectors of the hkl starting from the center of a facet
stereo pair | switch stereo pair mode on/off. (you may also type the character "s" to the same effect)
[Rotation] menu
around X: 90 deg | rotate 90 degrees around screen normal
around X: -90 deg | rotate -90 degrees around screen normal
around X: custom | specify angle around screen normal
around X: auto | start animation around screen normal
around Y: 90 deg | rotate 90 degrees around horizontal axis
around Y: -90 deg | rotate -90 degrees around horizontal axis
around Y: custom | specify angle around horizontal axis
around Y: auto | start animation around horizontal axis
around Z: 90 deg | rotate 90 degrees around vertical axis
around Z: -90 deg | rotate -90 degrees around vertical axis
around Z: custom | specify angle around vertical axis
around Z: auto | start animation around vertical axis
stop auto rotation | stop animation
[Options] menu
create templates | generate 3675 mineral template files (data courtesy of Dave Barthelmy, www.webmineral.com)
print periodic table | print a colored periodic table of elements
[History] menu
cancel | close history menu
..... | history entries (full path is shown as tooltiptext)
clear history | remove all entries from history list
[Help] menu
about | show splash screen
show key bindings | show a list with keyboard shortcuts. Note that for keyboard actions to be executed the display area has to have the keyboard focus. If necessary click on the display area first.
help on JCrystal | open the default web-browser on your system for viewing this document.
JCrystal homepage | (Internet connection required) go to http://www.jcrystal.com
submit bug report | (Internet connection required) open web browser with bug report page
check for updates | (Internet connection required) open web browser with update download page
web databases | (Internet connection required) direct access to Dave Barthelmy's Webmineral database and the Russian MINCRYST database
Internet links .. | (Internet connection required) web addresses of mineralogical interest


Key-bindings

Note that you may have to click on the display area first to give it the keyboard focus.

display options
f
fit to screen
s
stereo pair on/off
i
indices on/off
n
face numbers on/off
v
vertex numbers on/off
e
edge drawing on/off

The cursor keys may be used for rotations, which might be useful for MAC users.

crystal rotation
SHIFT + any cursor key
rotation about x-axis (screen normal)
up/down cursor key
rotation about y-axis (horizontal axis)
left/right cursor key
rotation about z-axis (vertical axis)
start animation
x X
animate around x-axis (pos./neg.direction)
y Y
animate around y-axis (pos./neg.direction)
z Z
animate around z-axis (pos./neg.direction)
during animation
SPACE
start/stop animation
+
increase speed (angle step)
-
decrease speed (angle step)


Mouse Functions

Mouse Usage

Double Click on display area to switch animation on/off

change display modes
right mouse button click on canvas
rotation [ in ROTATE mode ]
left mouse button drag
rotate about y-,z-axes (horizontal/vertical axis)
right mouse button drag
rotate about x-axis (screen normal)
zoom [ in ZOOM mode ]
left mouse button drag
zoom image
editors color palette
left mouse button drag
change crystal color
right mouse button drag
change background color
left mouse button click
select color for faces; then you may click at the checkbox of a face with the right mouse button to assign that color to it

MAC users may use the cursor keys for the rotations, since there only one mouse button on a MAC mouse.


POVray

POVray - Persistence of Vision™ Ray Tracer

JCrystal can also export crystal shapes in form of POVRAY files (*.pov).

POVray is a free software that can be obtained freely at http://www.povray.org . POVray is included on the JCrystal CD at no additional cost. It is free and only included for the user's convenience.

This distribution of the official version of POV-Ray is permitted under the terms of the General License in the file POVLEGAL.DOC. The POV-Team does not endorse the distributor or its products. The POV-Team receives no compensation for this distribution.

Click here to view the file POVLEGAL.DOC

The POVray installation program is located on the CD in the directory POVRAY\

Export of crystal shapes for raytracing

Select the menu item [File][save as POVRAY]. You will then be asked for a filename. Then a dialog with rendering options will appear.

After you installed the POVray program, press the [path] button for specifying the location of the file [povray_install_directory]\bin\pvengine.exe .


New Page 1

Tutorial

  • How do I create a quasicrystal shape ?
  • How do I create a normal crystal shape ?
  • How do I use the form explorers ?
  • How do I modify face distances ?


Contacts

Author:

Steffen Weber
Livermore, CA 94550, USA

Phone:

Email:
Web:

 +1(USA) 925-455-1669

jcrystalsoft@gmail.com
http://www.jcrystal.com
http://www.jcrystal.com/steffenweber

JCrystalSoft homepage:

http://www.jcrystal.com


Unitcell Viewer

Visualize space relationships between lattice vectors [uvw] and plane normals (hkl). In most cases the (hkl) will be to short. Select the [unit length] checkbox and use the slider to adjust the lengths of the vectors. Only those vectors will be drawn whose checkbox is checked.

Leave a SPACE between the h k l or u v w values when you specify the vectors.

  1. display area - drag mouse for rotations
  2. color settings
  3. unit cell parameters
  4. vector lengths and angles
  5. toggle rotate mode-zoom(left mouse button) & shift(right mouse button) mode
  6. toggle stereo mode (parallel view not cross-eye view)
  7. toggle orthonormal/perspective projection
  8. scale vectors to unit length
  9. additional scaling factor if unit length is selected
  10. apply changes and recalculate
  11. vector indices and selector checkboxes


Stereograms

Program for plotting poles (hkl) or zone axes [uvw] onto a Wulff net. The Wulff net may be moved around with right mouse button drags.

  1. menu bar
  2. color settings
  3. select orientation vector format
  4. orientation vector indices (separated by SPACE)
  5. maximum index for hkl-loop (internally twice that number is used to find all equivalents!)
  6. unit cell constants
  7. select d-spacing range as additional criterion
  8. rotation angles
  9. sliders for zoom and rotation
  10. apply changes
  11. display area (click at spot for indexing; right mouse drag for moving)


Laue Patterns

Simulate geometrical Laue patterns (no intensity calculation, since no structure given)

  1. unit cell constants
  2. Laue geometry - transmission/back reflection
  3. color settings
  4. annotation for printout
  5. orientation vector (h SPACE k SPACE l)
  6. maximum index for hkl-loop (used if [Option][Automatic hkl limits] unchecked)
  7. X-ray generator voltage for minimum wavelength
  8. film width/height
  9. film distance
  10. lattice type for Bravais extinctions
  11. spot radius option
  12. swap x-coordinates (look towards beam or away from it)
  13. Apply changes (recalculate)
  14. zoom slider (also right-mouse-drag in right half of main display)
  15. threshold for displaying hkl labels


Periodic Table

  1. table of element (click at box to select element)
  2. numerical value of selected element property
  3. property graph for all elements (atomic numbers 1-98) (click to select element)
  4. select element property for the graph display


Paper Models

JCrystal provides a selection of polyhedra that can be printed out as unfolded paper models. The list might be extended in future updates.

Press color buttons in order to change the polygon fill color.


New Page 1

How do I create a normal crystal shape ?

First select the menu [File][New hkl-file] in order to begin a new shape.

In order to create a crystal shape one may either manually enter all hkl values and distances into the editor list or use the form creator tool for generating equivalent hkls from one starting hkl. Then select the "form" tab. Select the crystal symmetry (point group), enter a staring hkl (h SPACE k SPACE l), choose a color for the new faces and press the "get hkl list" button and then the "add to list" button. Repeat for all forms you may wish to add. The example below shows how the {110} and {111} forms with different colors are created.

After the hkl values have been added to the editor table press the "recalculate" button in order to display the newly created shape. If some faces would be missing, due to unsuitable distance values ("dist." value field would be highlighted in red) one has to adjust the value until the face becomes visible. One can either manually change the value and then recalculate or press the "Auto-adjust" button, in which case JCrystal tries to modify the misbehaving distance values until the faces become visible.

If one prefers to use the distance slider see "How to I use the distance slider ?"

Don't forget to save your newly created shape under a descriptive filename.


New Page 1

How do I modify face distances ?

A simple and easy-to-use interactive tool for adjusting the central distances of selected faces is the distance slider. Select the menu [View][Distance slider] to make it visible.
Check the checkbox of the faces, of which the distance values shall be modified and move the slider until the desired shape is created.
In order to undo the slider action select the menu [Edit][Reset distance slider].

In the example below the (100) face is selected and its distance changed.


New Page 1

How do I use the form explorers ?

There are two form explorers in JCrystal, which provide an easy means to create equivalent hkl from one input hkl.

If the starting hkl are known the form creator on the "form" tab should be used. Just choose the point group symmetry, provide the initial hkl (format: h SPACE k SPACE l) and central distance, choose a color for the new faces and press the "get hkl list" button. The generated hkls will be shown in the text area, in which individual lines may still be deleted manually. For accepting the list and sending them to the editor press the "add to list " button. Once the new facets are added to the editor table one may press the editor's recalculate button (right arrow) to create the new shape. It may be necessary to adjust the central distances to create a shape with all the facets being visible.

If the form explorer from the menu [Edit][Form explorer] is used one may also use a mouse-driven hkl input by clicking/dragging a point on the Wulff-net. Upon releasing the mouse button a preview shape is displayed, which can also be rotated by dragging it with the mouse.

Fig. Form explorer and simple form creator


New Page 1

How do I create a quasicrystal shape ?

In order to create the shape of an icosahedral quasicrystal one may use the form explorer from the menu [Edit][Form explorer].
First select the menu [File][New hkl-file] in order to begin a new shape. Then start the form explorer and follow the steps shown below.

Fig. Steps for creating a quasicrystal shape

Icosahedral quasicrystal faces require six integer indices (hklmno) or three fractional hkl values. The latter is method is used by JCrystal.


               Persistence of Vision(tm) Ray Tracer

                      POV-Ray(tm) Version 3.1g

                   Legal Information and License

                             May 1999

             GENERAL LICENSE AGREEMENT -- POVLEGAL.DOC

THIS NOTICE MUST ACCOMPANY ALL OFFICIAL OR CUSTOM PERSISTENCE OF
VISION FILES. IT MAY NOT BE REMOVED OR MODIFIED. THIS INFORMATION
PERTAINS TO ALL USE OF THE PACKAGE WORLDWIDE.  THIS DOCUMENT
SUPERSEDES ALL PREVIOUS GENERAL LICENSES OR DISTRIBUTION POLICIES.
ANY INDIVIDUALS, COMPANIES OR GROUPS WHO HAVE BEEN GRANTED SPECIAL
LICENSES MAY CONTINUE TO DISTRIBUTE VERSION 2.x BUT MUST RE-APPLY
FOR VERSION 3.00 OR LATER.

This document pertains to the use and distribution of the
Persistence of Vision(tm) Ray Tracer a.k.a POV-Ray(tm). It applies
to all POV-Ray program source files, executable (binary) files,
scene files, documentation files, help file, bitmaps and INI files
contained in official POV-Ray Team(tm) archives.  All of these are
referred to here as "the software". The POV-Team reserves the
right to revise these rules in future versions and to make
additional rules to address new circumstances at any time.

All of this software is Copyright 1991,1999 by the POV-Ray
Team(tm). Although it is distributed as freeware, it is NOT PUBLIC
DOMAIN.

The copyrighted package may ONLY be distributed and/or modified
according to the license granted herein.  The spirit of the
license is to promote POV-Ray as a standard ray tracer, provide
the full POV-Ray package freely to as many users as possible,
prevent POV-Ray users and developers from being taken advantage
of, enhance the life quality of those who come in contact with POV-
Ray.  This license was created so these goals could be realized.
You are legally bound to follow these rules, but we hope you will
follow them as a matter of ethics, rather than fear of litigation.

                         USAGE PROVISIONS

Permission is granted to the user to use the software and
associated files in this package to create and render images. The
use of this software for the purpose of creating images is
completely free. The creator of a scene file and the image created
from the scene file, retains all rights to the image and scene
file they created and may use them for any purpose commercial or
non-commercial.

The user is also granted the right to use the scenes files, fonts,
bitmaps, and include files distributed in the INCLUDE and
SCENES\INCDEMO sub-directories in their own scenes.  Such
permission does not extend to files in the SCENES directory or its
sub-directories.  The SCENES files are for your enjoyment and
education but may not be the basis of any derivative works.

                GENERAL RULES FOR ALL DISTRIBUTION

The permission to distribute this package under certain very
specific conditions is granted in advance, provided that the
following conditions are met.

These archives must not be re-archived using a different method
without the explicit permission of the POV-Team.  You may rename
the archives only to meet the file name conventions of your system
or to avoid file name duplications but we ask that you try to keep
file names as similar to the originals as possible.  (For example:
POVSRC.ZIP to POVSRC30.ZIP)

Ready-to-run unarchived distribution on CD-ROM is also permitted
if the files are arranged in our standard directory or folder
structure as though it had been properly installed on a hard disk.

You must distribute a FULL PACKAGE of files as described in the
next section.  No portion of this package may be separated from
the package and distributed separately other than under the
conditions specified in the provisions given below.

Non-commercial distribution in which no money or compensation is
charged (such as a user copying the software for a personal friend
or colleague) is permitted with no other restrictions.

Teachers and educational institutions may also distribute the
material to students for free or they may charge minimal copying
costs if the software is to be used in a course.

                   DEFINITION OF "FULL PACKAGE"

A "full package" contains an executable program, documentation,
and sample scenes.  For generic Unix platforms, there are no
executables available so the portable C source code must be
included instead of the executable program.

POV-Ray is officially distributed for MS-Dos; Windows 95/98/NT;
Linux for Intel x86 series; Apple Macintosh; Apple PowerPC; SunOS;
and Amiga. Other systems may be added in the future.

Distributors need not support all platforms but for each platform
you support you must distribute a full package. For example a
Macintosh only CD-ROM need not distribute the Windows versions.

This software may ONLY be bundled with other software packages
according to the conditions specified in the provisions below.

   CONDITIONS FOR CD-ROM OR SHAREWARE/FREEWARE DISTRIBUTION

Shareware and freeware distribution companies may distribute the
software included in software-only compilations using media such
as, but not limited to, floppy disk, CD-ROM, tape backup, optical
disks, hard disks, or memory cards. This section only applies to
distributors of collected programs. Anyone wishing to bundle the
package with a shareware product must use the commercial bundling
rules.

Distribution on CD-ROM or high capacity media such as backup tape
is permitted if the total cost to the user is no more than $0.08
U.S. dollars per megabyte of data. For example a CD-ROM with 600
meg could cost no more than $48.00 US.

Any bundling with books,magazines or other print media is
permitted if the total cost of the book or magazine with CD is
less than the $48.00 limit.  Bundling with more expensive
publications or distributions should use the commercial rules.

For floppy disk distribution, no more than five dollars U.S. ($5)
can be charged per disk for the copying of this software and the
media it is provided on. Space on each disk must be used as fully
as possible. You may not spread the files over more disks than are
necessary.

   CONDITIONS FOR ON-LINE SERVICES AND BBS'S INCLUDING INTERNET

On-line services, BBS's and internet sites may distribute the POV-
Ray software under the conditions in this section. Sites which
allow users to run POV-Ray from remote locations must use separate
provisions in the section below.

The archives must all be easily available on the service and
should be grouped together in a similar on-line area.

It is strongly requested that sites remove prior versions of POV-
Ray to avoid user confusion and simplify or minimize our support
efforts.

The site may only charge standard usage rates for the downloading
of this software. A premium may not be charged for this package.
I.E. CompuServe or America On-Line may make these archives
available to their users, but they may only charge regular usage
rates for the time required to download.

               ONLINE OR REMOTE EXECUTION OF POV-Ray

Some internet sites have been set up so that remote users can
actually run POV-Ray software on the internet server. Other
companies sell CPU time for running POV-Ray software on
workstations or high-speed computers. Such use of POV-Ray software
is permitted under the following conditions.

Fees or charges, if any, for such services must be for connect
time, storage or processor usage ONLY. No premium charges may be
assessed for use of POV-Ray beyond that charged for use of other
software. Users must be clearly notified that they are being
charged for use of the computer and not for use of POV-Ray
software.

Users must be prominently informed that they are using POV-Ray
software, that such software is free, and where they can find
official POV-Ray software. Any attempt to obscure the fact that
the user is running POV-Ray is expressly prohibited.

All files normally available in a full package distribution,
especially a copy of this license and full documentation must be
available for download or readable online so that users of an
online executable have access to all of the material of a full
user package.

If the POV-Ray software has been modified in any way, it must also
follow the provisions for custom versions below.

            PERMITTED MODIFICATION AND CUSTOM VERSIONS

Although the full source code for POV-Ray is distributed, there
are strict rules for the use of the source code. The source
distribution is provided to;  1) promote the porting of POV-Ray to
hardware and operating systems which the POV-Team cannot support.
2) promote experimentation and development of new features to the
core code which might eventually be incorporated into the official
version.  3) provide insight into the inner workings of the
program for educational purposes.

These license provisions have been established to promote the
growth of POV-Ray and prevent difficulties for users and
developers alike. Please follow them carefully for the benefit of
all concerned when creating a custom version.

The user is granted the privilege to modify and compile the source
code for their own personal use in any fashion they see fit. What
you do with the software in your own home is your business.

However severe restrictions are imposed if the user wishes to
distribute a modified version of the software, documentation or
other parts of the package (here after referred to as a "custom
version"). You must follow the provisions given below. This
includes any translation of the documentation into other languages
or other file formats.

A "custom version" is defined as a fully functional version of POV-
Ray with all existing features intact. ANY OTHER USE OF ANY POV-
Ray SOURCE CODE IS EXPRESSLY PROHIBITED. The POV-Team does not
license source code for any use outside POV-Ray. No portion of the
POV-Ray source code may be incorporated into another program
unless it is clearly a custom version of POV-Ray that includes all
of the basic functions of POV-Ray.

All executables, documentation, modified files and descriptions of
the same must clearly identify themselves as a modified and
unofficial version of POV-Ray. Any attempt to obscure the fact
that the user is running POV-Ray or to obscure that this is an
unofficial version expressly prohibited.

POV-Ray may not be linked into other software either at compile-
time using an object code linker nor at run-time as a DLL,
ActiveX, or other system. Such linkage can tend to blur the end-
user's perception of which program provides which functions and
thus qualifies as an attempt to obscure what is running.

To allow POV-Ray to communicate with outside programs, the official
versions of POV-Ray include several internal communication "hooks"
for it to call other tasks, often called an Application Programming
Interface, or API. For example: the generic part of POV-Ray provides
operating system shell-out API commands. The Windows version has a
GUI-extension API and the ability to replace the text editor.
Modification to these APIs or other officially supported
communication mechanisms to increase functionality beyond that of
the official version IS EXPRESSLY PROHIBITED.

          CONDITIONS FOR DISTRIBUTION OF CUSTOM VERSIONS

If your re-compiled version meets all requirements for custom
versions listed above, the following conditions apply to its
distribution:

You must provide all POV-Ray support for all users who use your
custom version. You must provide information so that user may
contact you for support for your custom version. The POV-Ray Team
is not obligated to provide you or your users any technical
support.

Include contact information in the DISTRIBUTION_MESSAGE macros in
the source file OPTOUT.H and insure that the program prominently
displays this information. Display all copyright notices and
credit screens for the official version.

Custom versions may only be distributed as freeware. You must make
all of your modifications to POV-Ray freely and publicly available
with FULL SOURCE CODE to the modified portions of POV-Ray and must
freely distribute full source to any new parts of the custom
version. The goal is that users must be able to re-compile the
program themselves using readily available compilers and run-time
libraries and to be able to further improve the program with their
own modifications.

You must provide documentation for any and all modifications that
you have made to the program that you are distributing. Include
clear and obvious information on how to obtain the official POV-
Ray.

The user is encouraged to send enhancements and bug fixes to the
POV-Ray Team, but the team is in no way required to utilize these
enhancements or fixes. By sending material to the team, the
contributor asserts that he owns the materials or has the right to
distribute these materials. He authorizes the team to use the
materials any way they like. The contributor still retains rights
to the donated material, but by donating, grants unrestricted,
irrevocable usage and distribution rights to the POV- Team. The
team doesn't have to use the material, but if we do, you do not
acquire any rights related to POV-Ray. The team will give you
credit as the creator of new code if applicable.

Include a copy of this document (POVLEGAL.DOC).

                CONDITIONS FOR COMMERCIAL BUNDLING

Vendors wishing to bundle POV-Ray with commercial software
(including shareware) or other distribution not already described
above must first obtain explicit permission from the POV-Team.
Such permission is rarely granted. The POV-Team will decide if
such distribution will be allowed on a case-by-case basis and may
impose certain restrictions as it sees fit. The minimum terms are
given below. Other conditions may be imposed.

    The product must be an existing product that has proven itself
as commercially viable without POV-Ray included.

    The inclusion of POV-Ray should be promoted only as a free
bonus and not as a feature designed to encourage customers to
purchase or upgrade solely for the POV-Ray capability.

    Purchasers of your product must not be led to believe that
they are paying for POV-Ray. Any mention of the POV-Ray bundle on
the box, in advertising or in instruction manuals must be clearly
marked with a disclaimer that POV-Ray is free software and can be
obtained for free or nominal cost from various sources.

    Include clear and obvious information on how to obtain the
official POV-Ray.

    You must provide all POV-Ray support for all users who
acquired POV- Ray through your product. The POV-Team is not
obligated to provide you or your customers any technical support.

    Include a credit page or pages in your documentation for POV-
Ray.

    If you modify any portion POV-Ray for use with your hardware
or software, you must follow the custom version rules in addition
to these rules.

    Include contact and support information for your product.

    Include a full user package as described above.

                 POV-Team ENDORSEMENT PROHIBITIONS

On rare occasions, the POV-Team endorses distributions in which
POV-Team members are compensated participants and which the POV-
Team has given approval.

Without specific approval, distributors (whether free or
commercial) must not claim or imply in any way that the POV-Team
officially endorses or supports the distributor or the product
(such as CD, book, or magazine) associated with the distribution.

You may not claim or imply that the POV-Team derives any benefit
from your distribution.

If you wish to emphasize that your distribution is legal, you may
use this language "This distribution of the official version of
POV-Ray is permitted under the terms of the General License in the
file POVLEGAL.DOC. The POV- Team does not endorse the distributor
or its products. The POV-Team receives no compensation for this
distribution."

                   RETAIL VALUE OF THIS SOFTWARE

Although POV-Ray is, when distributed within the terms of this
agreement, free of charge, the retail value (or price) of this
program is determined as US$20.00 per copy distributed or copied.
If the software is distributed or copied without authorization you
are legally liable to this debt to the copyright holder or any
other person or organization delegated by the copyright holder for
the collection of this debt, and you agree that you are legally
bound by the above and will pay this debt within 30 days of the
event.

However, none of the above paragraph constitutes permission for
you to distribute this software outside of the terms of this
agreement. In particular, the conditions and debt mentioned above
(whether paid or unpaid) do not allow you to avoid statutory
damages or other legal penalties and does not constitute any
agreement that would allow you to avoid such other legal remedies
as are available to the copyright holder.

Put simply, POV-Ray is only free if you comply with our
distribution conditions; it is not free otherwise. The copyright
holder of this software chooses to give it away free under these
and only these conditions.

For the purpose of copyright regulations, the retail value of this
software is US$20.00 per copy.

                         OTHER PROVISIONS

The team permits and encourages the creation of programs,
including commercial packages, which import, export or translate
files in the POV-Ray Scene Description Language. There are no
restrictions on use of the language itself. We reserve the right
to add or remove or change any part of the language.

"POV-Ray", "Persistence of Vision", "POV-Team" and "POV-Help" are
trademarks of the POV-Team.

While we do not claim any restrictions on the letters "POV" alone,
we humbly request that you not use POV in the name of your
product. Such use tends to imply it is a product of the POV-Team.
Existing programs which used "POV" prior to the publication of
this document need not feel guilty for doing so provided that you
make it clear that the program is not the work of the team nor
endorsed by us.

                       REVOCATION OF LICENSE

VIOLATION OF THIS LICENSE IS A VIOLATION OF COPYRIGHT LAWS. IT
WILL RESULT IN REVOCATION OF ALL DISTRIBUTION PRIVILEGES AND MAY
RESULT IN CIVIL OR CRIMINAL PENALTY.

Such violators who are prohibited from distribution will be
identified in this document.

In this regard, "PC Format", a magazine published by Future
Publishing, Ltd. in the United Kingdom, distributed incomplete
versions of POV-Ray 1.0 in violation the license which was effect
at the time. They later attempted to distribute POV-Ray 2.2
without prior permission of the POV- Team in violation the license
which was in effect at the time. There is evidence that other
Future Publishing companies have also violated our terms.
Therefore "PC Format", and any other magazine, book or CD-ROM
publication owned by Future Publishing is expressly prohibited
from any distribution of POV-Ray software until further notice.

                            DISCLAIMER

This software is provided as is without any guarantees or
warranty. Although the authors have attempted to find and correct
any bugs in the package, they are not responsible for any damage
or losses of any kind caused by the use or misuse of the package.
The authors are under no obligation to provide service,
corrections, or upgrades to this package.

                 ---End of License Information---

We sincerely hope you have fun with our program. If you have any
problems with the program, the team would like to hear about them.
Also, if you have any comments, questions or enhancements, please the
POV-Ray Team on the internet at http://www.povray.org or our private
news server news.povray.org with over a dozen povray-related news
groups.  The USENET group comp.graphics.rendering.raytracing is also a
great source of information on POV-Ray and related topics. License
inquiries should be made via email and limited technical support is
available via email to:

POV-Ray Team Coordinator team-coord@povray.org

The following postal address is only for official license business
and only if email is impossible.

We do not provide technical support via regular mail, only email.
We don't care if you don't have a modem or online access. We will
not mail you disks with updated versions. Do not send money.

Chris Young; 3119 Cossell Drive; Indianapolis, IN 46224 U.S.A.

The other authors' contact information may be found in the
documentation.